> ## Documentation Index
> Fetch the complete documentation index at: https://docs.bey.dev/llms.txt
> Use this file to discover all available pages before exploring further.

# Update Agent

> Update agent.



## OpenAPI

````yaml /openapi.json patch /v1/agents/{id}
openapi: 3.1.0
info:
  title: FastAPI
  version: 0.1.0
servers:
  - url: https://api.bey.dev
security: []
paths:
  /v1/agents/{id}:
    patch:
      tags:
        - Agents
      summary: Update Agent
      description: Update agent.
      operationId: update_agent_v1_agents__id__patch
      parameters:
        - name: id
          in: path
          required: true
          schema:
            type: string
            description: Agent ID.
            title: Id
          description: Agent ID.
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/UpdateAgentRequest'
      responses:
        '204':
          description: Successful Update
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
      security:
        - APIKeyHeader: []
components:
  schemas:
    UpdateAgentRequest:
      properties:
        name:
          type: string
          maxLength: 100
          minLength: 1
          title: Name
          description: Display name to use. Also used when addressed in conversations.
          examples:
            - Jarvis
            - HAL 9000
        avatar_id:
          type: string
          maxLength: 100
          minLength: 1
          title: Avatar Id
          description: ID of avatar to use.
          examples:
            - 01234567-89ab-cdef-0123-456789abcdef
        system_prompt:
          type: string
          maxLength: 10000
          minLength: 1
          title: System Prompt
          description: System prompt to use.
          examples:
            - You are a helpful assistant.
        language:
          anyOf:
            - $ref: '#/components/schemas/Language'
            - type: 'null'
          description: Language to use.
          examples:
            - en
            - en-US
            - de
        greeting:
          anyOf:
            - type: string
              maxLength: 1000
              minLength: 1
            - type: 'null'
          title: Greeting
          description: What to say when a call starts.
          examples:
            - Hello!
        max_session_length_minutes:
          anyOf:
            - type: integer
              maximum: 90
              exclusiveMinimum: 0
            - type: 'null'
          title: Max Session Length Minutes
          description: Maximum session length in minutes.
          examples:
            - 30
        capabilities:
          $ref: '#/components/schemas/AgentCapabilityList'
          description: Extra capabilities to manage calls.
          examples:
            - - type: webcam_vision
              - triggers:
                  - hey agent
                  - hi pal
                type: wakeup_mode
        llm:
          anyOf:
            - $ref: '#/components/schemas/AgentLlm'
            - type: 'null'
          description: Configuration for LLM to use.
          examples:
            - type: openai
            - api_id: 01234567-89ab-cdef-0123-456789abcdef
              model: gpt-4o-mini
              temperature: 0.7
              type: openai_compatible
        tts:
          anyOf:
            - $ref: '#/components/schemas/AgentTts'
            - type: 'null'
          description: Configuration for TTS to use.
          examples:
            - type: elevenlabs
              voice: 21m00Tcm4TlvDq8ikWAM
        knowledge_file_ids:
          items:
            type: string
            minLength: 1
          type: array
          uniqueItems: true
          title: Knowledge File Ids
          description: IDs of knowledge files to refer to.
      type: object
      title: UpdateAgentRequest
      description: Request body to update an agent. Omitted fields are unchanged.
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    Language:
      type: string
      enum:
        - ar
        - ar-SA
        - bn
        - bg
        - zh
        - cs
        - da
        - nl
        - en
        - en-AU
        - en-GB
        - en-US
        - fi
        - fr
        - fr-CA
        - fr-FR
        - de
        - el
        - hi
        - hu
        - id
        - it
        - ja
        - kk
        - ko
        - ms
        - 'no'
        - pl
        - pt
        - pt-BR
        - pt-PT
        - ro
        - ru
        - sk
        - es
        - sv
        - tr
        - uk
        - ur
        - vi
      title: Language
      description: Language for communication.
    AgentCapabilityList:
      items:
        $ref: '#/components/schemas/AgentCapability'
      type: array
    AgentLlm:
      oneOf:
        - $ref: '#/components/schemas/LivekitAgentLlm'
        - $ref: '#/components/schemas/OpenaiAgentLlm'
        - $ref: '#/components/schemas/OpenaiCompatibleAgentLlm'
      discriminator:
        propertyName: type
        mapping:
          livekit:
            $ref: '#/components/schemas/LivekitAgentLlm'
          openai:
            $ref: '#/components/schemas/OpenaiAgentLlm'
          openai_compatible:
            $ref: '#/components/schemas/OpenaiCompatibleAgentLlm'
    AgentTts:
      oneOf:
        - $ref: '#/components/schemas/LivekitAgentTts'
        - $ref: '#/components/schemas/ElevenlabsAgentTts'
        - $ref: '#/components/schemas/DeepgramAgentTts'
        - $ref: '#/components/schemas/OpenaiAgentTts'
        - $ref: '#/components/schemas/GoogleAgentTts'
      discriminator:
        propertyName: type
        mapping:
          deepgram:
            $ref: '#/components/schemas/DeepgramAgentTts'
          elevenlabs:
            $ref: '#/components/schemas/ElevenlabsAgentTts'
          google_tts:
            $ref: '#/components/schemas/GoogleAgentTts'
          livekit:
            $ref: '#/components/schemas/LivekitAgentTts'
          openai_tts:
            $ref: '#/components/schemas/OpenaiAgentTts'
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
    AgentCapability:
      oneOf:
        - $ref: '#/components/schemas/WebcamVisionAgentCapability'
        - $ref: '#/components/schemas/WakeupModeAgentCapability'
      discriminator:
        propertyName: type
        mapping:
          wakeup_mode:
            $ref: '#/components/schemas/WakeupModeAgentCapability'
          webcam_vision:
            $ref: '#/components/schemas/WebcamVisionAgentCapability'
    LivekitAgentLlm:
      properties:
        type:
          type: string
          const: livekit
          title: Type
          default: livekit
        model:
          type: string
          title: Model
        reasoning_effort:
          anyOf:
            - type: string
              enum:
                - low
                - medium
                - high
                - xhigh
            - type: 'null'
          title: Reasoning Effort
      type: object
      required:
        - model
      title: LivekitAgentLlm
      description: Configuration for LLMs supported via LiveKit Inference.
    OpenaiAgentLlm:
      properties:
        type:
          type: string
          const: openai
          title: Type
          default: openai
        model:
          type: string
          enum:
            - gpt-4.1-mini
            - gpt-4.1
          title: Model
          default: gpt-4.1-mini
      type: object
      title: OpenaiAgentLlm
      description: Configuration for OpenAI LLM.
    OpenaiCompatibleAgentLlm:
      properties:
        type:
          type: string
          const: openai_compatible
          title: Type
          default: openai_compatible
        api_id:
          type: string
          title: Api Id
        model:
          type: string
          title: Model
        temperature:
          type: number
          title: Temperature
        headers:
          additionalProperties:
            type: string
          type: object
          title: Headers
      type: object
      required:
        - api_id
        - model
        - temperature
      title: OpenaiCompatibleAgentLlm
      description: >-
        Configuration for an LLM provided by an OpenAI-compatible API.


        The notion of "OpenAI-compatible API" is somewhat fuzzy, there is no

        agreed upon standard for what it means.

        In practice, we care if the API is compatible with how LiveKit's openai

        plugin interacts with it, i.e. a subset of OpenAI's API specification
        that

        provides chat completions:

        https://platform.openai.com/docs/api-reference/completions
    LivekitAgentTts:
      properties:
        type:
          type: string
          const: livekit
          title: Type
          default: livekit
        model:
          type: string
          title: Model
        voice:
          type: string
          title: Voice
      type: object
      required:
        - model
        - voice
      title: LivekitAgentTts
      description: Configuration for TTS supported via LiveKit Inference.
    ElevenlabsAgentTts:
      properties:
        type:
          type: string
          const: elevenlabs
          title: Type
          default: elevenlabs
        voice:
          anyOf:
            - type: string
            - type: 'null'
          title: Voice
      type: object
      title: ElevenlabsAgentTts
      description: Configuration for Elevenlabs TTS.
    DeepgramAgentTts:
      properties:
        type:
          type: string
          const: deepgram
          title: Type
          default: deepgram
        voice:
          anyOf:
            - type: string
            - type: 'null'
          title: Voice
      type: object
      title: DeepgramAgentTts
      description: Configuration for Deepgram TTS.
    OpenaiAgentTts:
      properties:
        type:
          type: string
          const: openai_tts
          title: Type
          default: openai_tts
        voice:
          anyOf:
            - type: string
            - type: 'null'
          title: Voice
      type: object
      title: OpenaiAgentTts
      description: Configuration for OpenAI TTS.
    GoogleAgentTts:
      properties:
        type:
          type: string
          const: google_tts
          title: Type
          default: google_tts
        voice:
          anyOf:
            - type: string
            - type: 'null'
          title: Voice
      type: object
      title: GoogleAgentTts
      description: Configuration for Google TTS.
    WebcamVisionAgentCapability:
      properties:
        type:
          type: string
          const: webcam_vision
          title: Type
          default: webcam_vision
      type: object
      title: WebcamVisionAgentCapability
      description: Agent capability to see user camera feed.
    WakeupModeAgentCapability:
      properties:
        type:
          type: string
          const: wakeup_mode
          title: Type
          default: wakeup_mode
        triggers:
          items:
            type: string
          type: array
          title: Triggers
      type: object
      required:
        - triggers
      title: WakeupModeAgentCapability
      description: Agent capability to wake up only on specific keywords.
  securitySchemes:
    APIKeyHeader:
      type: apiKey
      description: Your Beyond Presence API Key.
      in: header
      name: x-api-key

````